-------------------------------------------------- {COPYRIGHT-TOP-RM}
-- Licensed Materials - Property of IBM                              
--                                                                   
-- Restricted Materials of IBM                                     
--                                                                   
-- 5724-C51                                                          
--                                                                   
--  Copyright IBM Corp. 1999,2007 All Rights Reserved.            
--                                                                   
-- US Government Users Restricted Rights - Use, duplication or       
-- disclosure restricted by GSA ADP Schedule Contract with           
-- IBM Corp.                                                         
-------------------------------------------------- {COPYRIGHT-END-RM}
-- File: archive/db/sql/procs/alobgetrelatedbyclasssub.sql, tbsm_base, tbsm_base31e
-- SID: 1.1
-- Date Modified: 07/09/10 08:53:59
--
-- Module Description
--   Defines the alobGetRelatedByClassSub stored procedure

Use Object
GO

-------------------------------------------------------------------------
-- alobGetRelatedByClassSub
PRINT 'Creating procedure alobGetRelatedByClassSub'
GO

IF EXISTS ( SELECT * FROM sysobjects WHERE name = 'alobGetRelatedByClassSub' AND type = 'P')
  DROP PROCEDURE alobGetRelatedByClassSub
GO

-------------------------------------------------- {COPYRIGHT-TOP-RM}
-- Licensed Materials - Property of IBM                              
--                                                                   
-- Restricted Materials of IBM                                     
--                                                                   
-- 5724-C51                                                          
--                                                                   
--  Copyright IBM Corp. 1999,2007 All Rights Reserved.            
--                                                                   
-- US Government Users Restricted Rights - Use, duplication or       
-- disclosure restricted by GSA ADP Schedule Contract with           
-- IBM Corp.                                                         
-------------------------------------------------- {COPYRIGHT-END-RM}
-- File: archive/db/sql/procs/alobgetrelatedbyclasssub.sql, tbsm_base, tbsm_base31e
-- SID: 1.1
-- Date Modified: 07/09/10 08:53:59
                                                                                                                                                                                                                                                         

CREATE PROCEDURE alobGetRelatedByClassSub
AS

-- Insert into #data ascendents of iClass, iObject as seen in ObjPathCache
DECLARE @iClass         ClassID
DECLARE @iObject        ObjID
DECLARE @sPath          NVARCHAR( 256 )
DECLARE @iClassRelated  ClassID
DECLARE @iObjectRelated ObjID
DECLARE @nPos           INT

select distinct r.iClass , r.iObject
into #neededObjs
from #resultCriteria AS r
INNER JOIN #needed AS n on n.iClass = r.iClass and n.iObject = r.iObject
WHERE r.bSeed = 1

-- Filter cursor result set to only check those ObjPathCache which have objects in #needed.  
-- This is the same filter included when adding the ObjPathCache to #data below.
DECLARE c CURSOR FOR 
  SELECT DISTINCT o.cid, o.id, o.idpath FROM ObjPathCache AS o
  INNER JOIN #neededObjs AS r ON r.iClass = o.cid AND r.iObject = o.id

OPEN c
FETCH NEXT FROM c INTO @iClass, @iObject, @sPath
WHILE @@FETCH_STATUS <> -1
BEGIN 
  WHILE LEN( @sPath ) <> 0
  BEGIN
    SET @nPos          = PATINDEX( '%:%', @sPath )      
    SET @iClassRelated = LEFT( @sPath, @nPos - 1 )
    SET @sPath         = RIGHT( @sPath, LEN( @sPath ) - @nPos )
    SET @nPos          = PATINDEX( '%/%', @sPath ) 
    IF  0 <> @nPos 
    BEGIN
      SET @iObjectRelated = LEFT( @sPath, @nPos - 1 )
      SET @sPath          = RIGHT( @sPath, LEN( @sPath ) - @nPos )
    END
    ELSE
    BEGIN
      SET @iObjectRelated = @sPath
      SET @sPath           = ''
    END

    INSERT INTO #data (        iClass,         iObject,   iPattern,   sNameAttribute, sValueAttributeDeleted,
                        sValueAttributeInserted, iClassRelated, iObjectRelated,  iClassStart,    iObjectStart ) 
    SELECT DISTINCT    @iClassRelated, @iObjectRelated, n.iPattern, n.sNameAttribute,                   NULL,
                                           NULL,      n.iClass,      n.iObject, n.iClassStart, n.iObjectStart
    FROM #needed AS n
    WHERE 
             n.iClass        = @iClass
         AND n.iObject       = @iObject
         AND n.iClassRelated = @iClassRelated
         AND NOT EXISTS ( SELECT * FROM #resultCriteria AS r -- do not put rows in #data that already exist in #resultCriteria
                          WHERE
                                   r.iPattern       = n.iPattern
                               AND r.iClass         = @iClassRelated
                               AND r.iObject        = @iObjectRelated
                               AND r.iClassRelated  = n.iClass
                               AND r.iObjectRelated = n.iObject
                               AND r.iClassStart    = n.iClassStart
                               AND r.iObjectStart   = n.iObjectStart
                        )
         AND NOT EXISTS ( SELECT * FROM #data AS dup -- do not put rows in #data that already exist in #data
                  WHERE
                                   dup.iClass         = @iClassRelated
                               AND dup.iObject        = @iObjectRelated
                               AND dup.iPattern       = n.iPattern
                               AND dup.sNameAttribute = n.sNameAttribute
                               AND dup.iClassRelated  = n.iClass
                               AND dup.iObjectRelated = n.iObject
                               AND dup.iClassStart    = n.iClassStart
                               AND dup.iObjectStart   = n.iObjectStart
             )      
  END    
  FETCH NEXT FROM c INTO @iClass, @iObject, @sPath
END
CLOSE c
DEALLOCATE c

GO