-------------------------------------------------- {COPYRIGHT-TOP-RM}
-- Licensed Materials - Property of IBM                              
--                                                                   
-- Restricted Materials of IBM                                       
--                                                                   
-- 5724-C51                                                          
--                                                                   
--  Copyright IBM Corp. 1999,2006 All Rights Reserved.            
--                                                                   
-- US Government Users Restricted Rights - Use, duplication or       
-- disclosure restricted by GSA ADP Schedule Contract with           
-- IBM Corp.                                                         
-------------------------------------------------- {COPYRIGHT-END-RM}
-- File: archive/db/sql/tracks/oa22288.sql, tbsm_base, tbsm_base31e
-- SID: 1.1
-- Date Modified: 07/09/28 17:22:45
--
-- Module Description
--   Code to resolve current "bad" resources in maintenance mode tables

USE Object
GO

DECLARE @obj_cid ClassID, @cname NVARCHAR(24), @rc INT, @now NVARCHAR(40), @err INT
DECLARE cc INSENSITIVE CURSOR FOR 
  SELECT DISTINCT mts.cid, cname FROM MaintTrueState AS mts 
    JOIN obj_class AS c ON c.cid = mts.cid
OPEN cc
FETCH NEXT FROM cc INTO @obj_cid, @cname
WHILE @@FETCH_STATUS <> -1
BEGIN
  EXEC("
  DELETE mts
  FROM MaintTrueState AS mts
    JOIN " + @cname + "_V AS o ON o.id = mts.id
  WHERE mts.cid = '" + @obj_cid + "' AND o.deleted = 1
  ")
  SELECT @err = @@ERROR, @rc = @@ROWCOUNT
  IF @err <> 0
  BEGIN
    RAISERROR('@obj_cid=''%s'': Error deleting from MaintTrueState. Error=%d', 3, 1, @obj_cid, @err) WITH NOWAIT
  END
  SET @now = CONVERT(NVARCHAR, CURRENT_TIMESTAMP, 121)
  RAISERROR('%s: Number of inactive resources deleted for cid %s: %d', 0, 1, @now, @obj_cid, @rc) WITH NOWAIT
  FETCH NEXT FROM cc INTO @obj_cid, @cname
END
DEALLOCATE cc

GO